package com.sun.xml.internal.ws.api.message;

import org.xml.sax.SAXException;
import org.xml.sax.ErrorHandler;
import org.xml.sax.ContentHandler;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.stream.XMLStreamWriter;
import com.sun.xml.internal.ws.api.addressing.WSEndpointReference;
import com.sun.xml.internal.ws.api.addressing.AddressingVersion;
import com.sun.xml.internal.ws.spi.db.XMLBridge;
import com.sun.xml.internal.bind.api.Bridge;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;
import javax.xml.namespace.QName;
import com.sun.istack.internal.Nullable;
import java.util.Set;
import com.sun.istack.internal.NotNull;
import com.sun.xml.internal.ws.api.SOAPVersion;

public interface Header
{
    public abstract boolean isIgnorable(@NotNull SOAPVersion p0, @NotNull Set<String> p1);
    
    @NotNull
    public abstract String getRole(@NotNull SOAPVersion p0);
    
    public abstract boolean isRelay();
    
    @NotNull
    public abstract String getNamespaceURI();
    
    @NotNull
    public abstract String getLocalPart();
    
    @Nullable
    public abstract String getAttribute(@NotNull String p0, @NotNull String p1);
    
    @Nullable
    public abstract String getAttribute(@NotNull QName p0);
    
    public abstract XMLStreamReader readHeader() throws XMLStreamException;
    
    public abstract <T> T readAsJAXB(Unmarshaller p0) throws JAXBException;
    
    @Deprecated
    public abstract <T> T readAsJAXB(Bridge<T> p0) throws JAXBException;
    
    public abstract <T> T readAsJAXB(XMLBridge<T> p0) throws JAXBException;
    
    @NotNull
    public abstract WSEndpointReference readAsEPR(AddressingVersion p0) throws XMLStreamException;
    
    public abstract void writeTo(XMLStreamWriter p0) throws XMLStreamException;
    
    public abstract void writeTo(SOAPMessage p0) throws SOAPException;
    
    public abstract void writeTo(ContentHandler p0, ErrorHandler p1) throws SAXException;
    
    @NotNull
    public abstract String getStringContent();
}
